apiVersion: apps/v1
kind: Deployment
metadata:
  name: recorder
  annotations:
    reloader.stakater.com/auto: "true"
  labels:
    app.kubernetes.io/name: owntracks
    app.kubernetes.io/component: recorder
spec:
  replicas: 1
  selector:
    matchLabels:
      app.kubernetes.io/name: owntracks
      app.kubernetes.io/component: recorder
  template:
    metadata:
      labels:
        app.kubernetes.io/name: owntracks
        app.kubernetes.io/component: recorder
    spec:
      securityContext:
        runAsUser: 100
        runAsGroup: 101
        fsGroup: 100
        fsGroupChangePolicy: Always
      containers:
      - name: recorder
        image: owntracks/recorder:0.9.9@sha256:f2ba3b0c814e9b01fc519c6715cbdd8430363e06aa889c69c01b044e155d0c9e
        imagePullPolicy: IfNotPresent
        ports:
        - name: http
          containerPort: 8083
          protocol: TCP
        envFrom:
        - configMapRef:
            name: recorder-envs
        env:
        - name: OTR_PASS
          valueFrom:
            secretKeyRef:
              name: mosquitto-user # TODO: Use reflector/ESO to handle this nicely 💫
              key: password
        securityContext:
          readOnlyRootFilesystem: true
        volumeMounts:
        - name: recorder-store
          mountPath: /store
        # - name: mosquitto-config
        #   mountPath: /mosquitto/config/mosquitto.conf
        #   subPath: mosquitto.conf
      restartPolicy: Always
      volumes:
      - name: recorder-store
        persistentVolumeClaim:
          claimName: recorder-store
      # - name: mosquitto-config
      #   configMap:
      #     name: mosquitto-config
      # - name: mqtt-schober-space-tls
      #   secret:
      #     secretName: mqtt-schober-space-tls
      # - name: ephemeral-passwd
      #   emptyDir:
      #     sizeLimit: 1Mi
---
apiVersion: v1
kind: ConfigMap
metadata:
  name: recorder-envs
data:
  OTR_USER: "stefan"
  #OTR_PASS: <- in secret
  OTR_HOST: "mqtt.schober.space"
  OTR_PORT: "8883"
  OTR_CAFILE: "/etc/ssl/cert.pem"
---
apiVersion: v1
kind: PersistentVolumeClaim
metadata:
  name: recorder-store
spec:
  storageClassName: openebs-lvmpv
  accessModes:
  # Only RWO is supported by openebs/lvm (not RWX so no dedicated Cronjob ;()
  # Maybe in the future https://github.com/topolvm/topolvm/issues/502 can help?
  # Forget what I just wrote, just enable shared: true on storage class 🤦
  - ReadWriteOnce
  resources:
    requests:
      storage: 1Gi
---
apiVersion: v1
kind: Service
metadata:
  name: recorder
spec:
  ports:
  - port: 80
    targetPort: http
  selector:
    app.kubernetes.io/name: owntracks
    app.kubernetes.io/component: recorder

